--- //depot/projects/trustedbsd/mac/sys/security/mac_test/mac_test.c	2003/06/02 12:26:58
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/security/mac_test/mac_test.c	2003/06/13 16:12:32
@@ -57,6 +57,10 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
+#include <sys/msg.h>
+#include <sys/msg_msg.h>
+#include <sys/sem.h>
+#include <sys/shm.h>
 
 #include <fs/devfs/devfs.h>
 
@@ -85,6 +89,10 @@
 #define	MBUFMAGIC	0xbbefa5bb
 #define	MOUNTMAGIC	0xc7c46e47
 #define	SOCKETMAGIC	0x9199c6cd
+#define	SYSVIPCMSQMAGIC	0xea672391
+#define	SYSVIPCMSGMAGIC	0x8bbba61e
+#define	SYSVIPCSEMMAGIC	0x896e8a0b
+#define	SYSVIPCSHMMAGIC	0x76119ab0
 #define	PIPEMAGIC	0xdc6c9919
 #define	PROCMAGIC	0x3b4be98f
 #define	CREDMAGIC	0x9a5a4987
@@ -107,6 +115,14 @@
 	SLOT(x) == 0, ("%s: Bad MOUNT label", __func__ ))
 #define	ASSERT_SOCKET_LABEL(x)	KASSERT(SLOT(x) == SOCKETMAGIC ||	\
 	SLOT(x) == 0, ("%s: Bad SOCKET label", __func__ ))
+#define	ASSERT_SYSVIPCMSQ_LABEL(x)	KASSERT(SLOT(x) == SYSVIPCMSQMAGIC ||	\
+	SLOT(x) == 0, ("%s: Bad SYSVIPCMSQ label", __func__ ))
+#define	ASSERT_SYSVIPCMSG_LABEL(x)	KASSERT(SLOT(x) == SYSVIPCMSGMAGIC ||	\
+	SLOT(x) == 0, ("%s: Bad SYSVIPCMSG label", __func__ ))
+#define	ASSERT_SYSVIPCSEM_LABEL(x)	KASSERT(SLOT(x) == SYSVIPCSEMMAGIC ||	\
+	SLOT(x) == 0, ("%s: Bad SYSVIPCSEM label", __func__ ))
+#define	ASSERT_SYSVIPCSHM_LABEL(x)	KASSERT(SLOT(x) == SYSVIPCSHMMAGIC ||	\
+	SLOT(x) == 0, ("%s: Bad SYSVIPCSHM label", __func__ ))
 #define	ASSERT_PIPE_LABEL(x)	KASSERT(SLOT(x) == PIPEMAGIC ||		\
 	SLOT(x) == 0, ("%s: Bad PIPE label", __func__ ))
 #define	ASSERT_PROC_LABEL(x)	KASSERT(SLOT(x) == PROCMAGIC ||		\
@@ -132,6 +148,18 @@
 static int	init_count_ifnet;
 SYSCTL_INT(_security_mac_test, OID_AUTO, init_count_ifnet, CTLFLAG_RD,
     &init_count_ifnet, 0, "ifnet init calls");
+static int	init_count_ipc_msg;
+SYSCTL_INT(_security_mac_test, OID_AUTO, init_count_ipc_msg, CTLFLAG_RD,
+    &init_count_ipc_msg, 0, "ipc_msg init calls");
+static int	init_count_ipc_msq;
+SYSCTL_INT(_security_mac_test, OID_AUTO, init_count_ipc_msq, CTLFLAG_RD,
+    &init_count_ipc_msq, 0, "ipc_msq init calls");
+static int	init_count_ipc_sema;
+SYSCTL_INT(_security_mac_test, OID_AUTO, init_count_ipc_sema, CTLFLAG_RD,
+    &init_count_ipc_sema, 0, "ipc_sema init calls");
+static int	init_count_ipc_shm;
+SYSCTL_INT(_security_mac_test, OID_AUTO, init_count_ipc_shm, CTLFLAG_RD,
+    &init_count_ipc_shm, 0, "ipc_shm init calls");
 static int	init_count_ipq;
 SYSCTL_INT(_security_mac_test, OID_AUTO, init_count_ipq, CTLFLAG_RD,
     &init_count_ipq, 0, "ipq init calls");
@@ -173,6 +201,18 @@
 static int	destroy_count_ifnet;
 SYSCTL_INT(_security_mac_test, OID_AUTO, destroy_count_ifnet, CTLFLAG_RD,
     &destroy_count_ifnet, 0, "ifnet destroy calls");
+static int	destroy_count_ipc_msg;
+SYSCTL_INT(_security_mac_test, OID_AUTO, destroy_count_ipc_msg, CTLFLAG_RD,
+    &destroy_count_ipc_msg, 0, "ipc_msg destroy calls");
+static int	destroy_count_ipc_msq;
+SYSCTL_INT(_security_mac_test, OID_AUTO, destroy_count_ipc_msq, CTLFLAG_RD,
+    &destroy_count_ipc_msq, 0, "ipc_msq destroy calls");
+static int	destroy_count_ipc_sema;
+SYSCTL_INT(_security_mac_test, OID_AUTO, destroy_count_ipc_sema, CTLFLAG_RD,
+    &destroy_count_ipc_sema, 0, "ipc_sema destroy calls");
+static int	destroy_count_ipc_shm;
+SYSCTL_INT(_security_mac_test, OID_AUTO, destroy_count_ipc_shm, CTLFLAG_RD,
+    &destroy_count_ipc_shm, 0, "ipc_shm destroy calls");
 static int	destroy_count_ipq;
 SYSCTL_INT(_security_mac_test, OID_AUTO, destroy_count_ipq, CTLFLAG_RD,
     &destroy_count_ipq, 0, "ipq destroy calls");
@@ -267,6 +307,34 @@
 	atomic_add_int(&init_count_ifnet, 1);
 }
 
+static void
+mac_test_init_ipc_msgmsg_label(struct label *label)
+{
+	SLOT(label) = SYSVIPCMSGMAGIC;
+	atomic_add_int(&init_count_ipc_msg, 1);
+}
+
+static void
+mac_test_init_ipc_msgqueue_label(struct label *label)
+{
+	SLOT(label) = SYSVIPCMSQMAGIC;
+	atomic_add_int(&init_count_ipc_msq, 1);
+}
+
+static void
+mac_test_init_ipc_sema_label(struct label *label)
+{
+	SLOT(label) = SYSVIPCSEMMAGIC;
+	atomic_add_int(&init_count_ipc_sema, 1);
+}
+
+static void
+mac_test_init_ipc_shm_label(struct label *label)
+{
+	SLOT(label) = SYSVIPCSHMMAGIC;
+	atomic_add_int(&init_count_ipc_shm, 1);
+}
+
 static int
 mac_test_init_ipq_label(struct label *label, int flag)
 {
@@ -420,6 +488,62 @@
 }
 
 static void
+mac_test_destroy_ipc_msgmsg_label(struct label *label)
+{
+
+	if (SLOT(label) == SYSVIPCMSGMAGIC || SLOT(label) == 0) {
+		atomic_add_int(&destroy_count_ipc_msg, 1);
+		SLOT(label) = EXMAGIC;
+	} else if (SLOT(label) == EXMAGIC) {
+		Debugger("mac_test_destroy_ipc_msgmsg_label: dup destroy");
+	} else {
+		Debugger("mac_test_destroy_ipc_msgmsg_label: corrupted label");
+	}
+}
+
+static void
+mac_test_destroy_ipc_msgqueue_label(struct label *label)
+{
+
+	if (SLOT(label) == SYSVIPCMSQMAGIC || SLOT(label) == 0) {
+		atomic_add_int(&destroy_count_ipc_msq, 1);
+		SLOT(label) = EXMAGIC;
+	} else if (SLOT(label) == EXMAGIC) {
+		Debugger("mac_test_destroy_ipc_msgqueue_label: dup destroy");
+	} else {
+		Debugger("mac_test_destroy_ipc_msgqueue_label: corrupted label");
+	}
+}
+
+static void
+mac_test_destroy_ipc_sema_label(struct label *label)
+{
+
+	if (SLOT(label) == SYSVIPCSEMMAGIC || SLOT(label) == 0) {
+		atomic_add_int(&destroy_count_ipc_sema, 1);
+		SLOT(label) = EXMAGIC;
+	} else if (SLOT(label) == EXMAGIC) {
+		Debugger("mac_test_destroy_ipc_sema_label: dup destroy");
+	} else {
+		Debugger("mac_test_destroy_ipc_sema_label: corrupted label");
+	}
+}
+
+static void
+mac_test_destroy_ipc_shm_label(struct label *label)
+{
+
+	if (SLOT(label) == SYSVIPCSHMMAGIC || SLOT(label) == 0) {
+		atomic_add_int(&destroy_count_ipc_shm, 1);
+		SLOT(label) = EXMAGIC;
+	} else if (SLOT(label) == EXMAGIC) {
+		Debugger("mac_test_destroy_ipc_shm_label: dup destroy");
+	} else {
+		Debugger("mac_test_destroy_ipc_shm_label: corrupted label");
+	}
+}
+
+static void
 mac_test_destroy_ipq_label(struct label *label)
 {
 
@@ -822,6 +946,40 @@
 }
 
 static void
+mac_test_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr,
+								    struct label *msglabel)
+{
+
+	ASSERT_SYSVIPCMSG_LABEL(msglabel);
+}   
+
+static void 
+mac_test_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr,
+								    struct label *msqlabel)
+{
+
+	ASSERT_SYSVIPCMSQ_LABEL(msqlabel);
+}
+
+static void
+mac_test_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr,
+								    struct label *semalabel)
+{
+
+	ASSERT_SYSVIPCSEM_LABEL(semalabel);
+}
+
+static void
+mac_test_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								    struct label *shmlabel)
+{
+
+	ASSERT_SYSVIPCSHM_LABEL(shmlabel);
+}
+
+
+
+static void
 mac_test_create_ipq(struct mbuf *fragment, struct label *fragmentlabel,
     struct ipq *ipq, struct label *ipqlabel)
 {
@@ -1023,6 +1181,37 @@
 }
 
 /*
+ * Label cleanup/flush operations
+ */
+static void 
+mac_test_cleanup_ipc_msgmsg(struct label *msglabel)
+{
+
+	ASSERT_SYSVIPCMSG_LABEL(msglabel);
+}
+
+static void 
+mac_test_cleanup_ipc_msgqueue(struct label *msqlabel)
+{
+
+	ASSERT_SYSVIPCMSQ_LABEL(msqlabel);
+}
+
+static void 
+mac_test_cleanup_ipc_sema(struct label *semalabel)
+{
+
+	ASSERT_SYSVIPCSEM_LABEL(semalabel);
+}
+
+static void 
+mac_test_cleanup_ipc_shm(struct label *shmlabel)
+{
+
+	ASSERT_SYSVIPCSHM_LABEL(shmlabel);
+}
+
+/*
  * Access control checks.
  */
 static int
@@ -1079,6 +1268,143 @@
 }
 
 static int
+mac_test_check_ipc_msgmsq(struct ucred *cred, struct msg *msgptr, 
+								                        struct msqid_kernel *msqkptr)
+{
+	ASSERT_SYSVIPCMSQ_LABEL(&msqkptr->label);
+	ASSERT_SYSVIPCMSG_LABEL(&msgptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+  return (0);
+}
+    
+static int
+mac_test_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr)
+{   
+
+	ASSERT_SYSVIPCMSG_LABEL(&msgptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+  return (0);
+}
+
+
+static int
+mac_test_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr)
+{
+
+	ASSERT_SYSVIPCMSG_LABEL(&msgptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+  return (0);
+}
+
+static int
+mac_test_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+
+	ASSERT_SYSVIPCMSQ_LABEL(&msqkptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+  return (0);
+}
+
+static int
+mac_test_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+
+	ASSERT_SYSVIPCMSQ_LABEL(&msqkptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+  return (0);
+}
+
+static int
+mac_test_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+
+	ASSERT_SYSVIPCMSQ_LABEL(&msqkptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+  return (0);
+}
+
+
+static int
+mac_test_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,
+								                    int cmd)
+{
+
+	ASSERT_SYSVIPCMSQ_LABEL(&msqkptr->label);
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	return (0);
+}
+
+static int
+mac_test_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr,
+								                    int cmd)
+{
+
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSEM_LABEL(&semakptr->label);
+  return (0);
+}
+
+
+static int
+mac_test_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr)
+{
+
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSEM_LABEL(&semakptr->label);
+	return (0);
+}
+
+
+static int
+mac_test_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr,
+								                        size_t accesstype)
+{
+ 
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSEM_LABEL(&semakptr->label);
+	return (0);
+}
+
+
+static int
+mac_test_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int shmflg)
+{
+
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSHM_LABEL(&shmsegptr->label);
+  return (0);
+}
+
+static int
+mac_test_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int cmd)
+{
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSHM_LABEL(&shmsegptr->label);
+  return (0);
+}
+
+static int
+mac_test_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSHM_LABEL(&shmsegptr->label);
+	return (0);
+}
+
+static int
+mac_test_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                         int shmflg)
+{
+
+	ASSERT_CRED_LABEL(&cred->cr_label);
+	ASSERT_SYSVIPCSHM_LABEL(&shmsegptr->label);
+	return (0);
+}
+
+static int
 mac_test_check_kenv_dump(struct ucred *cred)
 {
 
@@ -1752,6 +2078,10 @@
 	.mpo_init_cred_label = mac_test_init_cred_label,
 	.mpo_init_devfsdirent_label = mac_test_init_devfsdirent_label,
 	.mpo_init_ifnet_label = mac_test_init_ifnet_label,
+	.mpo_init_ipc_msgmsg_label = mac_test_init_ipc_msgmsg_label,
+  .mpo_init_ipc_msgqueue_label = mac_test_init_ipc_msgqueue_label,
+  .mpo_init_ipc_sema_label = mac_test_init_ipc_sema_label,
+  .mpo_init_ipc_shm_label = mac_test_init_ipc_shm_label,
 	.mpo_init_ipq_label = mac_test_init_ipq_label,
 	.mpo_init_mbuf_label = mac_test_init_mbuf_label,
 	.mpo_init_mount_label = mac_test_init_mount_label,
@@ -1765,6 +2095,10 @@
 	.mpo_destroy_cred_label = mac_test_destroy_cred_label,
 	.mpo_destroy_devfsdirent_label = mac_test_destroy_devfsdirent_label,
 	.mpo_destroy_ifnet_label = mac_test_destroy_ifnet_label,
+	.mpo_destroy_ipc_msgmsg_label = mac_test_destroy_ipc_msgmsg_label,
+  .mpo_destroy_ipc_msgqueue_label = mac_test_destroy_ipc_msgqueue_label,
+  .mpo_destroy_ipc_sema_label = mac_test_destroy_ipc_sema_label,
+  .mpo_destroy_ipc_shm_label = mac_test_destroy_ipc_shm_label,
 	.mpo_destroy_ipq_label = mac_test_destroy_ipq_label,
 	.mpo_destroy_mbuf_label = mac_test_destroy_mbuf_label,
 	.mpo_destroy_mount_label = mac_test_destroy_mount_label,
@@ -1807,6 +2141,10 @@
 	.mpo_set_socket_peer_from_socket = mac_test_set_socket_peer_from_socket,
 	.mpo_create_bpfdesc = mac_test_create_bpfdesc,
 	.mpo_create_ifnet = mac_test_create_ifnet,
+	.mpo_create_ipc_msgmsg = mac_test_create_ipc_msgmsg,
+  .mpo_create_ipc_msgqueue = mac_test_create_ipc_msgqueue,
+  .mpo_create_ipc_sema = mac_test_create_ipc_sema,
+  .mpo_create_ipc_shm = mac_test_create_ipc_shm,
 	.mpo_create_datagram_from_ipq = mac_test_create_datagram_from_ipq,
 	.mpo_create_fragment = mac_test_create_fragment,
 	.mpo_create_ipq = mac_test_create_ipq,
@@ -1828,11 +2166,29 @@
 	.mpo_create_proc1 = mac_test_create_proc1,
 	.mpo_relabel_cred = mac_test_relabel_cred,
 	.mpo_thread_userret = mac_test_thread_userret,
+	.mpo_cleanup_ipc_msgmsg = mac_test_cleanup_ipc_msgmsg,
+	.mpo_cleanup_ipc_msgqueue = mac_test_cleanup_ipc_msgqueue,
+	.mpo_cleanup_ipc_sema = mac_test_cleanup_ipc_sema,
+	.mpo_cleanup_ipc_shm = mac_test_cleanup_ipc_shm,
 	.mpo_check_bpfdesc_receive = mac_test_check_bpfdesc_receive,
 	.mpo_check_cred_relabel = mac_test_check_cred_relabel,
 	.mpo_check_cred_visible = mac_test_check_cred_visible,
 	.mpo_check_ifnet_relabel = mac_test_check_ifnet_relabel,
 	.mpo_check_ifnet_transmit = mac_test_check_ifnet_transmit,
+	.mpo_check_ipc_msgmsq = mac_test_check_ipc_msgmsq,
+  .mpo_check_ipc_msgrcv = mac_test_check_ipc_msgrcv,
+  .mpo_check_ipc_msgrmid = mac_test_check_ipc_msgrmid,
+  .mpo_check_ipc_msqget = mac_test_check_ipc_msqget,
+  .mpo_check_ipc_msqsnd = mac_test_check_ipc_msqsnd,
+  .mpo_check_ipc_msqrcv = mac_test_check_ipc_msqrcv,
+  .mpo_check_ipc_msqctl = mac_test_check_ipc_msqctl,
+  .mpo_check_ipc_semctl = mac_test_check_ipc_semctl,
+  .mpo_check_ipc_semget = mac_test_check_ipc_semget,
+  .mpo_check_ipc_semop = mac_test_check_ipc_semop,
+  .mpo_check_ipc_shmat = mac_test_check_ipc_shmat,
+  .mpo_check_ipc_shmctl = mac_test_check_ipc_shmctl,
+  .mpo_check_ipc_shmdt = mac_test_check_ipc_shmdt,
+  .mpo_check_ipc_shmget = mac_test_check_ipc_shmget,
 	.mpo_check_kenv_dump = mac_test_check_kenv_dump,
 	.mpo_check_kenv_get = mac_test_check_kenv_get,
 	.mpo_check_kenv_set = mac_test_check_kenv_set,
--- //depot/projects/trustedbsd/mac/sys/sys/mac.h	2003/06/07 22:05:57
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/sys/mac.h	2003/06/13 16:12:32
@@ -39,6 +39,7 @@
  * The POSIX.1e implementation page may be reached at:
  * http://www.trustedbsd.org/
  */
+
 #ifndef _SYS_MAC_H
 #define	_SYS_MAC_H
 
@@ -122,6 +123,10 @@
 struct uio;
 struct vattr;
 struct vnode;
+struct msqid_kernel;
+struct msg;
+struct semid_kernel;
+struct shmid_kernel;
 
 #include <sys/acl.h>			/* XXX acl_type_t */
 
@@ -134,6 +139,10 @@
 void	mac_init_cred(struct ucred *);
 void	mac_init_devfsdirent(struct devfs_dirent *);
 void	mac_init_ifnet(struct ifnet *);
+void	mac_init_ipc_msgmsg(struct msg *);
+void	mac_init_ipc_msgqueue(struct msqid_kernel*);
+void	mac_init_ipc_sema(struct semid_kernel*);
+void	mac_init_ipc_shm(struct shmid_kernel*);
 int	mac_init_ipq(struct ipq *, int flag);
 int	mac_init_socket(struct socket *, int flag);
 void	mac_init_pipe(struct pipe *);
@@ -149,6 +158,10 @@
 void	mac_destroy_cred(struct ucred *);
 void	mac_destroy_devfsdirent(struct devfs_dirent *);
 void	mac_destroy_ifnet(struct ifnet *);
+void 	mac_destroy_ipc_msgmsg(struct msg *);
+void	mac_destroy_ipc_msgqueue(struct msqid_kernel *);
+void	mac_destroy_ipc_sema(struct semid_kernel *);
+void	mac_destroy_ipc_shm(struct shmid_kernel *);
 void	mac_destroy_ipq(struct ipq *);
 void	mac_destroy_socket(struct socket *);
 void	mac_destroy_pipe(struct pipe *);
@@ -196,6 +209,15 @@
 void	mac_create_pipe(struct ucred *cred, struct pipe *pipe);
 
 /*
+ * Labeling event operations: System V IPC primitives
+ */
+void mac_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr);
+void mac_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr);
+void mac_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr);
+void mac_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr);
+
+
+/*
  * Labeling event operations: network objects.
  */
 void	mac_create_bpfdesc(struct ucred *cred, struct bpf_d *bpf_d);
@@ -232,10 +254,44 @@
 void	mac_create_proc1(struct ucred *cred);
 void	mac_thread_userret(struct thread *td);
 
+/*
+ * Label cleanup operation: This is the inverse complement for the mac_create
+ * and associate type of hooks. This hook lets the policy module(s) perform a 
+ * cleanup/flushing operation on the label associated with the objects,
+ * without freeing up the space allocated. This hook is useful in cases where it
+ * is desirable to remove any labeling reference when recycling any object to a
+ * pool. This hook does not replace the mac_destroy hooks.
+ */
+void mac_cleanup_ipc_msgmsg(struct msg *msgptr);
+void mac_cleanup_ipc_msgqueue(struct msqid_kernel *msqkptr);
+void mac_cleanup_ipc_sema(struct semid_kernel *semakptr);
+void mac_cleanup_ipc_shm(struct shmid_kernel *shmsegptr);
+
 /* Access control checks. */
 int	mac_check_bpfdesc_receive(struct bpf_d *bpf_d, struct ifnet *ifnet);
 int	mac_check_cred_visible(struct ucred *u1, struct ucred *u2);
 int	mac_check_ifnet_transmit(struct ifnet *ifnet, struct mbuf *m);
+int mac_check_ipc_msgmsq(struct ucred *cred, struct msg *msgptr, 
+				struct msqid_kernel *msqkptr);
+int mac_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr);
+int mac_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr);
+int mac_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr);
+int mac_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr);
+int mac_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr);
+int mac_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,
+    int cmd);
+int mac_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr,
+		int cmd);
+int mac_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr);
+int mac_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr, 
+				size_t accesstype);
+int mac_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr, 
+				int shmflg);
+int mac_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr, 
+				int cmd);
+int	mac_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr);
+int mac_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr, 
+				int shmflg);
 int	mac_check_kenv_dump(struct ucred *cred);
 int	mac_check_kenv_get(struct ucred *cred, char *name);
 int	mac_check_kenv_set(struct ucred *cred, char *name, char *value);
--- //depot/projects/trustedbsd/mac/sys/sys/mac_policy.h	2003/06/07 22:05:57
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/sys/mac_policy.h	2003/06/13 16:12:32
@@ -74,6 +74,10 @@
 	void	(*mpo_init_cred_label)(struct label *label);
 	void	(*mpo_init_devfsdirent_label)(struct label *label);
 	void	(*mpo_init_ifnet_label)(struct label *label);
+	void	(*mpo_init_ipc_msgmsg_label)(struct label *label);
+	void	(*mpo_init_ipc_msgqueue_label)(struct label* label);
+	void  (*mpo_init_ipc_sema_label)(struct label* label);
+	void  (*mpo_init_ipc_shm_label)(struct label* label);
 	int	(*mpo_init_ipq_label)(struct label *label, int flag);
 	int	(*mpo_init_mbuf_label)(struct label *label, int flag);
 	void	(*mpo_init_mount_label)(struct label *label);
@@ -87,6 +91,10 @@
 	void	(*mpo_destroy_cred_label)(struct label *label);
 	void	(*mpo_destroy_devfsdirent_label)(struct label *label);
 	void	(*mpo_destroy_ifnet_label)(struct label *label);
+	void (*mpo_destroy_ipc_msgmsg_label)(struct label* label);
+	void (*mpo_destroy_ipc_msgqueue_label)(struct label* label);
+	void (*mpo_destroy_ipc_sema_label)(struct label* label);
+	void (*mpo_destroy_ipc_shm_label)(struct label* label);
 	void	(*mpo_destroy_ipq_label)(struct label *label);
 	void	(*mpo_destroy_mbuf_label)(struct label *label);
 	void	(*mpo_destroy_mount_label)(struct label *label);
@@ -192,6 +200,18 @@
 	void	(*mpo_create_pipe)(struct ucred *cred, struct pipe *pipe,
 		    struct label *pipelabel);
 
+	/*    
+	 * Labeling event operations: System V IPC primitives
+	 */
+	void (*mpo_create_ipc_msgmsg)(struct ucred *cred, 
+				struct msg *msgptr, struct label *msglabel);
+	void (*mpo_create_ipc_msgqueue)(struct ucred *cred, 
+				struct msqid_kernel *msqkptr, struct label *msqlabel);
+	void (*mpo_create_ipc_sema)(struct ucred *cred, 
+				struct semid_kernel *semakptr, struct label *semalabel); 
+	void (*mpo_create_ipc_shm)(struct ucred *cred, 
+				struct shmid_kernel *shmsegptr, struct label *shmlabel);
+
 	/*
 	 * Labeling event operations: network objects.
 	 */
@@ -261,6 +281,19 @@
 		    struct label *newlabel);
 	void	(*mpo_thread_userret)(struct thread *thread);
 
+	/* 
+	 * Label cleanup operation: This is the inverse complement for the mac_create
+	 * and associate type of hooks. This hook lets the policy module(s) perform a
+	 * cleanup/flushing operation on the label associated with the objects,
+	 * without freeing up the space allocated. This hook is useful in cases where 
+	 * it is desirable to remove any labeling reference when recycling any object 
+	 * to a pool. This hook does not replace the mac_destroy hooks.
+	 */
+	void (*mpo_cleanup_ipc_msgmsg)(struct label *msglabel);
+	void (*mpo_cleanup_ipc_msgqueue)(struct label *msqlabel);
+	void (*mpo_cleanup_ipc_sema)(struct label *semalabel);
+	void (*mpo_cleanup_ipc_shm)(struct label *shmlabel);
+
 	/*
 	 * Access control checks.
 	 */
@@ -276,6 +309,29 @@
 	int	(*mpo_check_ifnet_transmit)(struct ifnet *ifnet,
 		    struct label *ifnetlabel, struct mbuf *m,
 		    struct label *mbuflabel);
+	int (*mpo_check_ipc_msgmsq)(struct ucred *cred, struct msg *msgptr, 
+				struct msqid_kernel *msqkptr);
+	int (*mpo_check_ipc_msgrcv)(struct ucred *cred, struct msg *msgptr);
+  int (*mpo_check_ipc_msgrmid)(struct ucred *cred, struct msg *msgptr);
+	int (*mpo_check_ipc_msqget)(struct ucred *cred, struct msqid_kernel *msqkptr);
+	int (*mpo_check_ipc_msqsnd)(struct ucred *cred, struct msqid_kernel *msqkptr);
+	int (*mpo_check_ipc_msqrcv)(struct ucred *cred, struct msqid_kernel *msqkptr);
+	int (*mpo_check_ipc_msqctl)(struct ucred *cred, struct msqid_kernel *msqkptr,
+    int cmd);
+	int (*mpo_check_ipc_semctl)(struct ucred *cred, struct semid_kernel *semakptr,
+    int cmd);
+	int (*mpo_check_ipc_semget)(struct ucred *cred, 
+				struct semid_kernel *semakptr);
+	int (*mpo_check_ipc_semop)(struct ucred *cred, struct semid_kernel *semakptr, 
+				size_t accesstype);
+	int (*mpo_check_ipc_shmat)(struct ucred *cred, 
+				struct shmid_kernel *shmsegptr, int shmflg);
+	int (*mpo_check_ipc_shmctl)(struct ucred *cred, 
+				struct shmid_kernel *shmsegptr, int cmd);
+	int	(*mpo_check_ipc_shmdt)(struct ucred *cred, 
+				struct shmid_kernel *shmsegptr);
+	int (*mpo_check_ipc_shmget)(struct ucred *cred, 
+				struct shmid_kernel *shmsegptr, int shmflg);
 	int	(*mpo_check_kenv_dump)(struct ucred *cred);
 	int	(*mpo_check_kenv_get)(struct ucred *cred, char *name);
 	int	(*mpo_check_kenv_set)(struct ucred *cred, char *name,
--- //depot/projects/trustedbsd/mac/sys/sys/msg.h	2003/02/21 10:04:40
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/sys/msg.h	2003/05/29 11:51:12
@@ -26,6 +26,7 @@
 #include <sys/cdefs.h>
 #include <sys/_types.h>
 #include <sys/ipc.h>
+#include <sys/_label.h>
 
 /*
  * The MSG_NOERROR identifier value, the msqid_ds struct and the msg struct
@@ -120,6 +121,13 @@
 };
 extern struct msginfo	msginfo;
 
+struct msqid_kernel
+{
+        struct msqid_ds         u;
+        /* the following are private */
+	struct label label;         /* MAC label */
+};
+
 #else /* !_KERNEL */
 
 __BEGIN_DECLS
--- //depot/projects/trustedbsd/mac/sys/sys/sem.h	2003/02/21 10:04:40
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/sys/sem.h	2003/05/30 18:42:59
@@ -11,6 +11,7 @@
 #define _SYS_SEM_H_
 
 #include <sys/ipc.h>
+#include <sys/_label.h>
 
 struct sem;
 
@@ -84,6 +85,14 @@
 };
 extern struct seminfo	seminfo;
 
+/* Kernel wrapper for the user-level structure */
+struct semid_kernel
+{
+				  struct semid_ds   u;
+					  /* the following are private */
+					struct label label; /* MAC framework label */
+};
+
 /* internal "mode" bits */
 #define	SEM_ALLOC	01000	/* semaphore is allocated */
 #define	SEM_DEST	02000	/* semaphore will be destroyed on last detach */
--- //depot/projects/trustedbsd/mac/sys/sys/shm.h	2003/02/21 10:04:40
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/sys/shm.h	2003/06/02 19:36:08
@@ -40,6 +40,7 @@
 #define _SYS_SHM_H_
 
 #include <sys/ipc.h>
+#include <sys/_label.h>
 
 #define SHM_RDONLY  010000  /* Attach read-only (else read-write) */
 #define SHM_RND     020000  /* Round attach address to SHMLBA */
@@ -83,8 +84,20 @@
 		shmseg,		/* max shared memory segments per process */
 		shmall;		/* max amount of shared memory (pages) */
 };
+
+/* 
+ * Add a kernel wrapper to the shmid_ds struct so that private info
+ * (like the MAC label) can be added to it, without changing the user
+ * interface.
+ */
+struct shmid_kernel {
+	struct shmid_ds u;
+	/* the following are private */
+	struct label label; /* MAC label */
+};
+
 extern struct shminfo	shminfo;
-extern struct shmid_ds	*shmsegs;
+extern struct shmid_kernel	*shmsegs;
 
 struct shm_info {
 	int used_ids;
@@ -95,6 +108,7 @@
 	unsigned long swap_successes;
 };
 
+
 struct thread;
 struct proc;
 struct vmspace;
